#ifndef PCLDEFS
#define PCLDEFS
#ifndef _Windows
	 typedef int BOOL ;
    #define TRUE 1
    #define FALSE 0
    #define IDYES 6
#else
        #define WINPROG
        #include <windows.h>
#endif

#ifndef NULL
    #define NULL 0
#endif

#define MAX_TEXT_LEN 512

#define TERMINATE 2

#ifndef __BUILDER3__
//#error BUILDER3_NOT_DEFINED
#define CRAPPEND ios::out|ios::app|ios::ate|ios::binary
#define TCRAPPEND ios::out|ios::app|ios::ate
#define TRDONLY ios::in
#define TCRTRUNC ios::out|ios::trunc
#define TRDWR ios::out|ios::in
#define CRTRUNC ios::out|ios::trunc|ios::binary

#ifndef __DF2__

#define RDONLY ios::in|ios::binary
#define RDWR ios::out|ios::in|ios::binary

#endif
#else
#define CRAPPEND 0x02|0x08|0x04|0x80
#define TCRAPPEND 0x02|0x08|0x04
#define TRDONLY 0x01
#define TCRTRUNC 0x02|0x10
#define TRDWR 0x01|0x02
#define CRTRUNC 0x02|0x10|0x80

#ifndef __DF2__
#define RDONLY 0x01|0x80
#define RDWR 0x01|0x02|0x80
#endif

#endif
/*
    Compatibility with old file Streams
*/

#define OLD_RDWR    O_BINARY|O_CREAT|O_RDWR
#define OLD_RDONLY  O_BINARY|O_RDONLY
#define OLD_CR_APPEND O_BINARY|O_CREAT|O_APPEND|O_RDWR

#define PW_NAME_LEN 20                      /* User name length */
#define PW_PW_LEN 10                        /* Password length */
#define PW_PW_OFST 20                       /* password offset */
#define PW_LEV_LEN 1                        /* User level length */
#define PW_LEV_OFST 30
#define PW_DAY_OFST 31
#define PW_DAY_LEN 1
#define PW_MON_OFST 32
#define PW_MON_LEN 1
#define PW_YEAR_OFST 33
#define PW_YEAR_LEN 2
#define PW_TRIES_OFST 35
#define PW_TRIES_LEN 2
#define PW_LOGONS_OFST 37
#define PW_LOGONS_LEN 2
#define PW_ENTRY_LEN PW_NAME_LEN+PW_PW_LEN+PW_LEV_LEN+PW_DAY_LEN+PW_MON_LEN+PW_YEAR_LEN+PW_TRIES_LEN+PW_LOGONS_LEN

#define PW_NAME_FORM "%-20.20s"
#define PW_PW_FORM "%-10.10s"

#define GROUP_NAME_LEN 21

#define FALSE 0
#define TRUE 1


//********************************************************
// Validation Rules
//********************************************************
#define VDDMMYY 11
#define VDDMMYYYY 12
#define VMMDDYY 13
#define VMMDDYYYY 14
#define VDDMMMYY 15
#define VDDMMMYYYY 16
#define VDDMM 17
#define VMMDD 18
#define VYYMMDD 19
#define VYYYYMMDD 20
#define VYYMMMDD 21
#define VYYYYMMMDD 22
#define VDD_MM_YY 23
#define VDD_MM_YYYY 24
#define VMM_DD_YY 25
#define VMM_DD_YYYY 26
#define VDD_MMM_YY 27
#define VDD_MMM_YYYY 28
#define VDD_MM 29
#define VMM_DD 30
#define VYY_MM_DD 31
#define VYYYY_MM_DD 32
#define VYY_MMM_DD 33
#define VYYYY_MMM_DD 34
#define VALPHA 35
#define VALPHANUM 36
#define VNUM 37
#define VNUM_1_TO_9 38
#define VPATH 39
#define FILE_MUST_EXIST 40
#define VNUM_1_TO_99 41
#define VNUM_1_TO_30 42
#define VNUM_0_TO_32767 43
#define VY_OR_N 44
#define VNUM_0_TO_99 45
#define VNUM_0_TO_30 46

#define EBCDICH 0xC8



#define BS 8
#define FORMFEED 12
#define FF 12
#define LF 10
#define CR 13
#define TAB 9
#define BACKTAB 271
#define ESC 27
#define HOMEKEY 327
#define ENDKEY 335
#define UPKEY 328
#define DOWNKEY 336
#define PGUPKEY 329
#define PGDNKEY 337
#define LEFTKEY 331
#define INSKEY 338
#define RIGHTKEY 333
#define DELKEY 339
#define CTRLLEFTKEY 371
#define CTRLRIGHTKEY 372
#define CTRLPGUP 388
#define CTRLPGDN 374

#define F1 315
#define F2 316
#define F3 317
#define F4 318
#define F5 319
#define F6 320
#define F7 321
#define F8 322
#define F9 323
#define F10 324

#define SF1 340
#define SF2 341
#define SF3 342
#define SF4 343
#define SF5 344
#define SF6 345
#define SF7 346
#define SF8 347
#define SF9 348
#define SF10 349

#define CF1 350
#define CF2 351
#define CF3 352
#define CF4 353
#define CF5 354
#define CF6 355
#define CF7 356
#define CF8 357
#define CF9 358
#define CF10 359

#define AF1 360
#define AF2 361
#define AF3 362
#define AF4 363
#define AF5 364
#define AF6 365
#define AF7 366
#define AF8 367
#define AF9 368
#define AF10 369


/*
    Site specific info in range 1    -  999.
    Site/database info in range 1000 - 1999
    User specific info in range 2000 - 2999
      Messagefile user-specifics    2500 -
    User/database info in range 3000 - 3999
*/

#define GRACE_LOGINS 1
#define LOG_LOGINS 2
#define MONTHS_PASSWORD_VALID 3
#define SITE_SPARE4 4
#define RESERVED_SPACE 5
#define NEXT_DISK_NO 6
#define NEXT_DATA_FILE_NO 7
#define LOGIN_ATTEMPTS 8
#define MIRRORING 9
#define MODIFY_NOTES 10
#define SITE_SPARE11 11
#define LOG_LOGIN_ERRORS 12
#define DATE_FORMAT 13
#define JB_MIRROR   14
#define PERSONAL_SITE 15
#define SITE_SPARE16 16
#define SITE_SPARE17 17
#define SITE_SPARE18 18
#define SITE_SPARE19 19
#define SITE_SPARE20 20
#define SITE_SPARE21 21
#define SITE_SPARE22 22
#define SITE_SPARE23 23
#define SITE_SPARE24 24
#define SITE_SPARE25 25
#define SITE_SPARE26 26
#define SITE_SPARE27 27
#define SITE_SPARE28 28
#define SITE_SPARE29 29
#define SITE_SPARE30 30

/*
    Site/database info in range 1000 - 1999
*/
#define LEADER_LENGTH 1000
#define PAGE_SEPARATOR 1001
#define MAX_LINES 1002
#define DEBUG_LEVEL 1003
#define CONTROL_FILE 1004
#define LIST_SEPARATOR 1005
#define TPLHEADER_LINES 1006
#define TPLSCAN_LINES 1007
#define SITE_DBSPARE8 1008
#define SITE_DBSPARE9 1009
#define SITE_DBSPARE10 1010
#define SITE_DBSPARE11 1011
#define SITE_DBSPARE12 1012
#define SITE_DBSPARE13 1013
#define SITE_DBSPARE14 1014
#define SITE_DBSPARE15 1015
#define SITE_DBSPARE16 1016
#define SITE_DBSPARE17 1017
#define SITE_DBSPARE18 1018
#define SITE_DBSPARE19 1019
#define SITE_DBSPARE20 1020

/*
    User specific info in range 2000 - 2999
*/
#define PROGRAM_PATH 2000
#define MESSAGE_PATH 2001
#define HELP_PATH 2002
#define SYSSET_PATH 2003
#define PARAM_PATH 2004
#define SYSTEM_ID 2005
#define HOME_PATH 2006
#define LOGIN_PATH 2007
#define LOG_ERR_PATH 2008
#define MENU_PATH 2009
#define USER_SPARE10 2010
#define USER_SPARE11 2011
#define USER_SPARE12 2012
#define LOCAL_PATH 2013
#define PRET_LAST_SELECTED 2014
#define MUSIC_PAPER 2015
#define SCROLL_BARS 2016
#define TOOL_BAR 2017
#define SEARCH_COLOUR 2018
#define FORM_COLOUR 2019
#define MUSIC_COLOUR 2020
#define HOLD_COLOUR 2021
#define FORM_HEIGHT 2022
#define FORM_WIDTH 2023
#define FORM_LEFT 2024
#define FORM_TOP 2025
#define FONT_NAME 2026
#define FONT_PIXELS 2027
#define FONT_COLOUR 2028
#define FONT_HEIGHT 2029
#define FONT_PITCH 2030
#define FONT_BOLD 2031
#define FONT_ITALIC 2032
#define FONT_UNDERLINE 2033
#define FONT_STRIKEOUT 2034
#define TOOL_LEFT 2035
#define TOOL_TOP 2036
#define JUKEBOXES 2037
#define LAST_START 2038
#define LAST_END 2039
#define USER_SPARE40 2040
#define PCL_DEBUG 2041
#define USER_SPARE42 2042
#define USER_SPARE43 2043
#define OPTICAL_PATH 2044
#define AUDIBLE_ERRORS 2045
#define POLL_INDEX 2046
#define USER_SPARE47 2047
#define USER_SPARE48 2048
#define USER_SPARE49 2049
#define USER_SPARE50 2050
#define USER_SPARE51 2051
#define USER_SPARE52 2052
#define USER_SPARE53 2053
#define USER_SPARE54 2054
#define USER_SPARE55 2055
#define USER_SPARE56 2056
#define USER_SPARE57 2057
#define USER_SPARE58 2058
#define USER_SPARE59 2059
#define USER_SPARE60 2060
#define EDFONT_NAME 2065
#define EDFONT_PIXELS 2066
#define EDFONT_COLOUR 2067
#define EDFONT_HEIGHT 2068
#define EDFONT_PITCH 2069
#define EDFONT_BOLD 2070
#define EDFONT_ITALIC 2071
#define EDFONT_UNDERLINE 2072
#define EDFONT_STRIKEOUT 2073
#define EDFORM_COLOUR 2074
#define EDFORM_HEIGHT 2075
#define EDFORM_WIDTH 2076
#define EDFORM_LEFT 2077
#define EDFORM_TOP 2078
#define MENU_PICTURE 2079
#define MENU_TOP 2080
#define MENU_LEFT 2081
#define MENU_WIDTH 2082
#define MENU_HEIGHT 2083
#define MENU_AUTOCHANGE 2084
#define MENU_PICTURE_PATH 2085
//  Messagefile settings specific to users start at 2500
#define EFTFORM_COLOUR 2500
#define EFTFONT_NAME 2501
#define EFTFONT_PIXELS 2502
#define EFTFONT_COLOUR 2503
#define EFTFONT_HEIGHT 2504
#define EFTFONT_PITCH 2505
#define EFTFONT_BOLD 2506
#define EFTFONT_ITALIC 2507
#define EFTFONT_UNDERLINE 2508
#define EFTFONT_STRIKEOUT 2509
#define EFTSOURCE_PATH 2510
#define EFTDEST_PATH 2511
#define EFT_SPARE12 2512
#define EFT_SPARE13 2513
#define EFT_SPARE14 2514
#define EFT_SPARE15 2515
#define EFT_SPARE16 2516
#define EFT_SPARE17 2517
#define EFT_SPARE18 2518
#define EFT_SPARE19 2519
#define EFT_SPARE20 2520
#define EFT_SPARE21 2521
#define EFT_SPARE22 2522
#define EFT_SPARE23 2523
#define EFT_SPARE24 2524
#define EFT_SPARE25 2525
#define EFT_SPARE26 2526

/*
    User/database info in range 3000 - 3999
*/
#define INDEX_PATH 3000
#define DATA_DRIVE 3001
#define DATA_DIRECTORY 3002
#define LAST_DRIVE 3003
#define FIRST_MIRROR 3004
#define LAST_MIRROR 3005
#define NOTE_PATH 3006
#define NOTE_MIRROR_PATH 3007
#define USE_INTERIM 3008
#define MAX_INTERIM 3009
#define INTERIM_PATH 3010
#define USE_INTERIM1 3011
#define INTERIM_PATH1 3012
#define USER_DBSPARE13 3013
#define USER_DBSPARE14 3014
#define USER_DBSPARE15 3015
#define USER_DBSPARE16 3016
#define USER_DBSPARE17 3017
#define USER_DBSPARE18 3018
#define USER_DBSPARE19 3019
#define USER_DBSPARE20 3020

/*
    Licence levels
*/

#define LIC_NETWORK  1
#define LIC_JUKEBOX  2
#define LIC_IMAGE    3
#define LIC_SPARE4   4
#define LIC_SPARE5   5
#define LIC_SPARE6   6
#define LIC_SPARE7   7
#define LIC_SPARE8   8
#define LIC_SPARE9   9
#define LIC_SPARE10   10
#define LIC_SPARE11   11
#define LIC_SPARE12   12
#define LIC_SPARE13   13
#define LIC_SPARE14   14
#define LIC_SPARE15   15
#define LIC_SPARE16   16
#define LIC_SPARE17   17
#define LIC_SPARE18   18
#define LIC_SPARE19   19
#define LIC_SPARE20   20

#define SEND_ROWCOL WM_USER + 1
#define STOP_ROWCOL WM_USER + 2
#define REFLISTBUILT WM_USER + 3
#define CLOSE_VIEWER WM_USER + 4
#define VIEWER_CLOSED WM_USER + 5
#define VIEWER_OPENED WM_USER + 6
#define VIEW_CASCADE WM_USER + 7
#define VIEW_POS  WM_USER + 8
#define CANCELHIT WM_USER + 9
#define VIEW_GRAPHIC WM_USER + 10
#define CLOSE_GRAPHIC WM_USER + 11
#define OPENDEMMESS WM_USER + 12
#define CLOSEDEMMESS WM_USER + 13
#define EXITDEMPROG WM_USER + 14
#define CHANGEBGND WM_USER + 15
#define CLOSEPRET WM_USER + 16
#define MESSSPARE17 WM_USER + 17
#define MESSSPARE18 WM_USER + 18
#define MESSSPARE19 WM_USER + 19
#define MESSSPARE20 WM_USER + 20


#endif

